#include "qswdisplay.h"
#include <qtimer.h>

#include "qpsword.h"


void QSWDisplay::showContextMenu() {
		((QPSword *)topLevelWidget())->showTextContextMenu();
		((QPSword *)topLevelWidget())->currentDisplay = this;
	}

QSWDisplay::QSWDisplay( QWidget *p, const char *name ) : QTextBrowser(p, name),
			menuTimer( this ) {
		connect( &menuTimer, SIGNAL( timeout() ), SLOT( showContextMenuSlot() ) );
	}


void QSWDisplay::showContextMenuSlot() {
	if (hasSelectedText()) {
		if (selOnClick != selectedText()) {
			menuTimer.start( 750, TRUE );
			if (hasSelectedText())
				selOnClick = selectedText();
			else selOnClick = "";
			return;
		}
	}
	showContextMenu();
}

void QSWDisplay::viewportMousePressEvent( QMouseEvent* e )
{
    menuTimer.start( 750, TRUE );
    if (hasSelectedText())
        selOnClick = selectedText();
    else selOnClick = "";
    QTextBrowser::viewportMousePressEvent(e);
}

void QSWDisplay::viewportMouseReleaseEvent( QMouseEvent* e )
{
    cancelMenuTimer();
    QTextBrowser::viewportMouseReleaseEvent(e);
}

void QSWDisplay::cancelMenuTimer()
{
    if( menuTimer.isActive() )
	menuTimer.stop();
}

void QSWDisplay::highlighted ( const QString & href ) {
}

